@JS()
library neon;

import 'dart:js' show JsObject;

import 'package:js/js.dart';

@JS('neon')
class Neon {
  external static dynamic get BLOCK;

  external static NeonMap decode(String input);
  external static String encode(dynamic data, [int options]);
}

@JS()
@anonymous
class NeonMap {
  external int get length;

  external dynamic get(String key);
  external void set(String key, Object value, [bool replace = true]);
  external void add(String key, Object value);
  external bool has(String key);
  external void forEach(void f(key, value));
  external bool isList();
  external List values();
  external List keys();
  external List<NeonProperties> items();
  external JsObject toObject();
}

@JS()
@anonymous
class NeonProperties {
  external dynamic get key;
  external dynamic get value;
}

@JS('neon.Dumper')
class Dumper {
  external static toText(NeonMap data);
}
